commit c1c259ea76c4d8c94f6d96c3fd0bbbece25785bf
Author: Joni Poikelin <joni.poikelin@qt.io>
Date:   Fri Dec 30 11:56:53 2016 +0200

    Support OpenGL core profile
    
    [ChangeLog][Qt Graphical Effects] Added QtGraphicalEffects support for
    OpenGL Core profile contexts.
    
    Task-number: QTBUG-42107
    Change-Id: I7111e2e6fb3a0b0391e76a17a8d091d288bfcc23
    Reviewed-by: Laszlo Agocs <laszlo.agocs@qt.io>

diff --git a/src/effects/Blend.qml b/src/effects/Blend.qml
index 3244ae8..f607f4e 100644
--- a/src/effects/Blend.qml
+++ b/src/effects/Blend.qml
@@ -37,7 +37,7 @@
 **
 ****************************************************************************/
 
-import QtQuick 2.0
+import QtQuick 2.8
 import QtGraphicalEffects.private 1.0
 
 /*!
@@ -380,7 +380,14 @@ Item {
         property string blendModeSubtract: "result.rgb = max(rgb1 - rgb2, vec3(0.0));"
         property string blendModeSoftLight: "result.rgb = rgb1 * ((1.0 - rgb1) * rgb2 + (1.0 - (1.0 - rgb1) * (1.0 - rgb2)));"
 
-        property string fragmentShaderBegin: "
+        property string fragmentCoreShaderWorkaround: (GraphicsInfo.profile === GraphicsInfo.OpenGLCoreProfile ? "#version 150 core
+            #define varying in
+            #define texture2D texture
+            out vec4 fragColor;
+            #define gl_FragColor fragColor
+        " : "")
+
+        property string fragmentShaderBegin: fragmentCoreShaderWorkaround + "
             varying mediump vec2 qt_TexCoord0;
             uniform highp float qt_Opacity;
             uniform lowp sampler2D backgroundSource;
diff --git a/src/effects/BrightnessContrast.qml b/src/effects/BrightnessContrast.qml
index 165f291..04da2f3 100644
--- a/src/effects/BrightnessContrast.qml
+++ b/src/effects/BrightnessContrast.qml
@@ -188,21 +188,6 @@ Item {
         anchors.fill: parent
         blending: !rootItem.cached
 
-        fragmentShader: "
-            varying mediump vec2 qt_TexCoord0;
-            uniform highp float qt_Opacity;
-            uniform lowp sampler2D source;
-            uniform highp float brightness;
-            uniform highp float contrast;
-            void main() {
-                highp vec4 pixelColor = texture2D(source, qt_TexCoord0);
-                pixelColor.rgb /= max(1.0/256.0, pixelColor.a);
-                highp float c = 1.0 + contrast;
-                highp float contrastGainFactor = 1.0 + c * c * c * c * step(0.0, contrast);
-                pixelColor.rgb = ((pixelColor.rgb - 0.5) * (contrastGainFactor * contrast + 1.0)) + 0.5;
-                pixelColor.rgb = mix(pixelColor.rgb, vec3(step(0.0, brightness)), abs(brightness));
-                gl_FragColor = vec4(pixelColor.rgb * pixelColor.a, pixelColor.a) * qt_Opacity;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/brightnesscontrast.frag"
     }
 }
diff --git a/src/effects/ColorOverlay.qml b/src/effects/ColorOverlay.qml
index b4dd3bd..afefa0b 100644
--- a/src/effects/ColorOverlay.qml
+++ b/src/effects/ColorOverlay.qml
@@ -142,15 +142,6 @@ Item {
 
         anchors.fill: parent
 
-        fragmentShader: "
-            varying mediump vec2 qt_TexCoord0;
-            uniform highp float qt_Opacity;
-            uniform lowp sampler2D source;
-            uniform highp vec4 color;
-            void main() {
-                highp vec4 pixelColor = texture2D(source, qt_TexCoord0);
-                gl_FragColor = vec4(mix(pixelColor.rgb/max(pixelColor.a, 0.00390625), color.rgb/max(color.a, 0.00390625), color.a) * pixelColor.a, pixelColor.a) * qt_Opacity;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/coloroverlay.frag"
     }
 }
diff --git a/src/effects/Colorize.qml b/src/effects/Colorize.qml
index 77078ef..d36dea3 100644
--- a/src/effects/Colorize.qml
+++ b/src/effects/Colorize.qml
@@ -231,65 +231,7 @@ Item {
 
         anchors.fill: parent
 
-        fragmentShader: "
-            varying mediump vec2 qt_TexCoord0;
-            uniform highp float qt_Opacity;
-            uniform lowp sampler2D source;
-            uniform highp float hue;
-            uniform highp float saturation;
-            uniform highp float lightness;
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/colorize.frag"
 
-            highp float RGBtoL(highp vec3 color) {
-                highp float cmin = min(color.r, min(color.g, color.b));
-                highp float cmax = max(color.r, max(color.g, color.b));
-                highp float l = (cmin + cmax) / 2.0;
-                return l;
-            }
-
-            highp float hueToIntensity(highp float v1, highp float v2, highp float h) {
-                h = fract(h);
-                if (h < 1.0 / 6.0)
-                    return v1 + (v2 - v1) * 6.0 * h;
-                else if (h < 1.0 / 2.0)
-                    return v2;
-                else if (h < 2.0 / 3.0)
-                    return v1 + (v2 - v1) * 6.0 * (2.0 / 3.0 - h);
-
-                return v1;
-            }
-
-            highp vec3 HSLtoRGB(highp vec3 color) {
-                highp float h = color.x;
-                highp float l = color.z;
-                highp float s = color.y;
-
-                if (s < 1.0 / 256.0)
-                    return vec3(l, l, l);
-
-                highp float v1;
-                highp float v2;
-                if (l < 0.5)
-                    v2 = l * (1.0 + s);
-                else
-                    v2 = (l + s) - (s * l);
-
-                v1 = 2.0 * l - v2;
-
-                highp float d = 1.0 / 3.0;
-                highp float r = hueToIntensity(v1, v2, h + d);
-                highp float g = hueToIntensity(v1, v2, h);
-                highp float b = hueToIntensity(v1, v2, h - d);
-                return vec3(r, g, b);
-            }
-
-            void main() {
-                lowp vec4 sample = texture2D(source, qt_TexCoord0);
-                sample = vec4(sample.rgb / max(1.0/256.0, sample.a), sample.a);
-                highp float light = RGBtoL(sample.rgb);
-                highp float c = step(0.0, lightness);
-                sample.rgb = HSLtoRGB(vec3(hue, saturation, mix(light, c, abs(lightness))));
-                gl_FragColor = vec4(sample.rgb * sample.a, sample.a) * qt_Opacity;
-            }
-        "
     }
 }
diff --git a/src/effects/ConicalGradient.qml b/src/effects/ConicalGradient.qml
index 51dda4e..ca65151 100644
--- a/src/effects/ConicalGradient.qml
+++ b/src/effects/ConicalGradient.qml
@@ -327,36 +327,7 @@ Gradient {
 
         onFragmentShaderChanged: startAngleChanged()
 
-        property string noMaskShader: "
-            varying mediump vec2 qt_TexCoord0;
-            uniform lowp sampler2D gradientSource;
-            uniform highp float qt_Opacity;
-            uniform highp float startAngle;
-            uniform highp vec2 center;
-
-            void main() {
-                const highp float PI = 3.14159265;
-                const highp float PIx2inv = 0.1591549;
-                highp float a = (atan((center.y - qt_TexCoord0.t), (center.x - qt_TexCoord0.s)) + PI - startAngle) * PIx2inv;
-                gl_FragColor = texture2D(gradientSource, vec2(0.0, fract(a))) * qt_Opacity;
-            }
-        "
-
-        property string maskShader: "
-            varying mediump vec2 qt_TexCoord0;
-            uniform lowp sampler2D gradientSource;
-            uniform lowp sampler2D maskSource;
-            uniform highp float qt_Opacity;
-            uniform highp float startAngle;
-            uniform highp vec2 center;
-
-            void main() {
-                lowp float maskAlpha = texture2D(maskSource, qt_TexCoord0).a;
-                const highp float PI = 3.14159265;
-                const highp float PIx2inv = 0.1591549;
-                highp float a = (atan((center.y - qt_TexCoord0.t), (center.x - qt_TexCoord0.s)) + PI - startAngle) * PIx2inv;
-                gl_FragColor = texture2D(gradientSource, vec2(0.0, fract(a))) * maskAlpha * qt_Opacity;
-            }
-        "
+        property string noMaskShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/conicalgradient_nomask.frag"
+        property string maskShader:   "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/conicalgradient_mask.frag"
     }
 }
diff --git a/src/effects/Desaturate.qml b/src/effects/Desaturate.qml
index 4bce9e2..13f3e85 100644
--- a/src/effects/Desaturate.qml
+++ b/src/effects/Desaturate.qml
@@ -141,16 +141,6 @@ Item {
 
         anchors.fill: parent
 
-        fragmentShader: "
-            varying highp vec2 qt_TexCoord0;
-            uniform highp float qt_Opacity;
-            uniform lowp sampler2D source;
-            uniform highp float desaturation;
-            void main(void) {
-                lowp vec4 textureColor = texture2D(source, qt_TexCoord0.st);
-                lowp float grayColor = (textureColor.r + textureColor.g + textureColor.b) / 3.0;
-                gl_FragColor = mix(textureColor, vec4(vec3(grayColor), textureColor.a), desaturation) * qt_Opacity;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/desaturate.frag"
     }
 }
diff --git a/src/effects/DirectionalBlur.qml b/src/effects/DirectionalBlur.qml
index a1b8f06..6965a52 100644
--- a/src/effects/DirectionalBlur.qml
+++ b/src/effects/DirectionalBlur.qml
@@ -37,7 +37,7 @@
 **
 ****************************************************************************/
 
-import QtQuick 2.0
+import QtQuick 2.8
 import QtGraphicalEffects.private 1.0
 
 /*!
@@ -263,7 +263,10 @@ Item {
         "
 
         function buildFragmentShader() {
-            var shader = fragmentShaderSkeleton
+            var shader = ""
+            if (GraphicsInfo.profile === GraphicsInfo.OpenGLCoreProfile)
+                shader += "#version 150 core\n#define varying in\n#define texture2D texture\nout vec4 fragColor;\n#define gl_FragColor fragColor\n"
+            shader += fragmentShaderSkeleton
             var expandSteps = ""
 
             if (transparentBorder) {
diff --git a/src/effects/Displace.qml b/src/effects/Displace.qml
index 35cf593..0ef5d96 100644
--- a/src/effects/Displace.qml
+++ b/src/effects/Displace.qml
@@ -185,34 +185,6 @@ Item {
 
         anchors.fill: parent
 
-        fragmentShader: "
-            varying highp vec2 qt_TexCoord0;
-            uniform highp float qt_Opacity;
-            uniform lowp sampler2D source;
-            uniform lowp sampler2D displacementSource;
-            uniform highp float displacement;
-            uniform highp float xPixel;
-            uniform highp float yPixel;
-
-            highp float linearstep(highp float e0, highp float e1, highp float x) {
-                return clamp((x - e0) / (e1 - e0), 0.0, 1.0);
-            }
-
-            void main() {
-                lowp vec4 offset = texture2D(displacementSource, qt_TexCoord0);
-                offset.xy -= vec2(0.5, 0.5);
-                offset.xy = offset.xy * step(vec2(1.0/256.0), abs(offset.xy));
-                highp vec2 tx = qt_TexCoord0 + (vec2(-offset.x, offset.y) * displacement);
-
-                lowp float e1 = linearstep(0.0, xPixel, tx.x);
-                lowp float e2 = linearstep(0.0, yPixel, tx.y);
-                lowp float e3 = 1.0 - linearstep(1.0, 1.0 + xPixel, tx.x);
-                lowp float e4 = 1.0 - linearstep(1.0, 1.0 + yPixel, tx.y);
-
-                lowp vec4 sample = texture2D(source, tx);
-                sample.rgb *= e1 * e2 * e3 * e4;
-                gl_FragColor = sample * qt_Opacity * offset.a;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/displace.frag"
     }
 }
diff --git a/src/effects/FastBlur.qml b/src/effects/FastBlur.qml
index 33561be..9c4c88b 100644
--- a/src/effects/FastBlur.qml
+++ b/src/effects/FastBlur.qml
@@ -177,43 +177,10 @@ Item {
     }
 
     /*! \internal */
-    property string __internalBlurVertexShader: "
-        attribute highp vec4 qt_Vertex;
-        attribute highp vec2 qt_MultiTexCoord0;
-        uniform highp mat4 qt_Matrix;
-        uniform highp float yStep;
-        uniform highp float xStep;
-        varying highp vec2 qt_TexCoord0;
-        varying highp vec2 qt_TexCoord1;
-        varying highp vec2 qt_TexCoord2;
-        varying highp vec2 qt_TexCoord3;
-
-        void main() {
-            qt_TexCoord0 = vec2(qt_MultiTexCoord0.x + xStep, qt_MultiTexCoord0.y + yStep * 0.36);
-            qt_TexCoord1 = vec2(qt_MultiTexCoord0.x + xStep * 0.36, qt_MultiTexCoord0.y - yStep);
-            qt_TexCoord2 = vec2(qt_MultiTexCoord0.x - xStep * 0.36, qt_MultiTexCoord0.y + yStep);
-            qt_TexCoord3 = vec2(qt_MultiTexCoord0.x - xStep, qt_MultiTexCoord0.y - yStep * 0.36);
-            gl_Position = qt_Matrix * qt_Vertex;
-        }
-    "
+    property string __internalBlurVertexShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/fastblur_internal.vert"
 
     /*! \internal */
-    property string __internalBlurFragmentShader: "
-        uniform lowp sampler2D source;
-        uniform lowp float qt_Opacity;
-        varying highp vec2 qt_TexCoord0;
-        varying highp vec2 qt_TexCoord1;
-        varying highp vec2 qt_TexCoord2;
-        varying highp vec2 qt_TexCoord3;
-
-        void main() {
-            highp vec4 sourceColor = (texture2D(source, qt_TexCoord0) +
-            texture2D(source, qt_TexCoord1) +
-            texture2D(source, qt_TexCoord2) +
-            texture2D(source, qt_TexCoord3)) * 0.25;
-            gl_FragColor = sourceColor * qt_Opacity;
-        }
-   "
+    property string __internalBlurFragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/fastblur_internal.frag"
 
     ShaderEffect {
         id: level0
@@ -470,28 +437,6 @@ Item {
 
         onLodChanged: calculateWeights()
 
-        fragmentShader: "
-            uniform lowp sampler2D source1;
-            uniform lowp sampler2D source2;
-            uniform lowp sampler2D source3;
-            uniform lowp sampler2D source4;
-            uniform lowp sampler2D source5;
-            uniform mediump float weight1;
-            uniform mediump float weight2;
-            uniform mediump float weight3;
-            uniform mediump float weight4;
-            uniform mediump float weight5;
-            uniform lowp float qt_Opacity;
-            varying mediump vec2 qt_TexCoord0;
-
-            void main() {
-                lowp vec4 sourceColor = texture2D(source1, qt_TexCoord0) * weight1;
-                sourceColor += texture2D(source2, qt_TexCoord0) * weight2;
-                sourceColor += texture2D(source3, qt_TexCoord0) * weight3;
-                sourceColor += texture2D(source4, qt_TexCoord0) * weight4;
-                sourceColor += texture2D(source5, qt_TexCoord0) * weight5;
-                gl_FragColor = sourceColor * qt_Opacity;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/fastblur.frag"
     }
 }
diff --git a/src/effects/GammaAdjust.qml b/src/effects/GammaAdjust.qml
index 610c52b..e146d06 100644
--- a/src/effects/GammaAdjust.qml
+++ b/src/effects/GammaAdjust.qml
@@ -178,17 +178,6 @@ luminance = pow(original_luminance, 1.0 / gamma); // The luminance is assumed to
 
         anchors.fill: parent
 
-        fragmentShader: "
-            varying highp vec2 qt_TexCoord0;
-            uniform highp float qt_Opacity;
-            uniform lowp sampler2D source;
-            uniform highp float gamma;
-            void main(void) {
-                highp vec4 originalColor = texture2D(source, qt_TexCoord0.st);
-                originalColor.rgb = originalColor.rgb / max(1.0/256.0, originalColor.a);
-                highp vec3 adjustedColor = pow(originalColor.rgb, vec3(gamma));
-                gl_FragColor = vec4(adjustedColor * originalColor.a, originalColor.a) * qt_Opacity;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/gammeadjust.frag"
     }
 }
diff --git a/src/effects/HueSaturation.qml b/src/effects/HueSaturation.qml
index 31c11b7..866a8a2 100644
--- a/src/effects/HueSaturation.qml
+++ b/src/effects/HueSaturation.qml
@@ -218,84 +218,6 @@ Item {
 
         anchors.fill: parent
 
-        fragmentShader: "
-            varying highp vec2 qt_TexCoord0;
-            uniform highp float qt_Opacity;
-            uniform highp sampler2D source;
-            uniform highp vec3 hsl;
-
-            highp vec3 RGBtoHSL(highp vec3 color) {
-                highp float cmin = min(color.r, min(color.g, color.b));
-                highp float cmax = max(color.r, max(color.g, color.b));
-                highp float h = 0.0;
-                highp float s = 0.0;
-                highp float l = (cmin + cmax) / 2.0;
-                highp float diff = cmax - cmin;
-
-                if (diff > 1.0 / 256.0) {
-                    if (l < 0.5)
-                        s = diff / (cmin + cmax);
-                    else
-                        s = diff / (2.0 - (cmin + cmax));
-
-                    if (color.r == cmax)
-                        h = (color.g - color.b) / diff;
-                    else if (color.g == cmax)
-                        h = 2.0 + (color.b - color.r) / diff;
-                    else
-                        h = 4.0 + (color.r - color.g) / diff;
-
-                    h /= 6.0;
-                }
-                return vec3(h, s, l);
-            }
-
-            highp float hueToIntensity(highp float v1, highp float v2, highp float h) {
-                h = fract(h);
-                if (h < 1.0 / 6.0)
-                    return v1 + (v2 - v1) * 6.0 * h;
-                else if (h < 1.0 / 2.0)
-                    return v2;
-                else if (h < 2.0 / 3.0)
-                    return v1 + (v2 - v1) * 6.0 * (2.0 / 3.0 - h);
-
-                return v1;
-            }
-
-            highp vec3 HSLtoRGB(highp vec3 color) {
-                highp float h = color.x;
-                highp float l = color.z;
-                highp float s = color.y;
-
-                if (s < 1.0 / 256.0)
-                    return vec3(l);
-
-                highp float v1;
-                highp float v2;
-                if (l < 0.5)
-                    v2 = l * (1.0 + s);
-                else
-                    v2 = (l + s) - (s * l);
-
-                v1 = 2.0 * l - v2;
-
-                highp float d = 1.0 / 3.0;
-                highp float r = hueToIntensity(v1, v2, h + d);
-                highp float g = hueToIntensity(v1, v2, h);
-                highp float b = hueToIntensity(v1, v2, h - d);
-                return vec3(r, g, b);
-            }
-
-            void main() {
-                lowp vec4 sample = texture2D(source, qt_TexCoord0);
-                sample = vec4(sample.rgb / max(1.0/256.0, sample.a), sample.a);
-                sample.rgb = mix(vec3(dot(sample.rgb, vec3(0.2125, 0.7154, 0.0721))), sample.rgb, 1.0 + hsl.y);
-                sample.xyz = RGBtoHSL(sample.rgb);
-                sample.rgb = HSLtoRGB(vec3(sample.x + hsl.x, sample.y, sample.z));
-                highp float c = step(0.0, hsl.z);
-                sample.rgb = mix(sample.rgb, vec3(c), abs(hsl.z));
-                gl_FragColor = vec4(sample.rgb * sample.a, sample.a) * qt_Opacity;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/huesaturation.frag"
     }
 }
diff --git a/src/effects/LevelAdjust.qml b/src/effects/LevelAdjust.qml
index 6580909..a13354d 100644
--- a/src/effects/LevelAdjust.qml
+++ b/src/effects/LevelAdjust.qml
@@ -432,42 +432,6 @@ Item {
         property variant gamma: Qt.vector3d(1.0 / Math.max(rootItem.gamma.x, 0.0001), 1.0 / Math.max(rootItem.gamma.y, 0.0001), 1.0 / Math.max(rootItem.gamma.z, 0.0001))
         anchors.fill: parent
 
-        fragmentShader: "
-            varying highp vec2 qt_TexCoord0;
-            uniform highp float qt_Opacity;
-            uniform lowp sampler2D source;
-            uniform highp vec3 minimumInputRGB;
-            uniform highp vec3 maximumInputRGB;
-            uniform highp float minimumInputAlpha;
-            uniform highp float maximumInputAlpha;
-            uniform highp vec3 minimumOutputRGB;
-            uniform highp vec3 maximumOutputRGB;
-            uniform highp float minimumOutputAlpha;
-            uniform highp float maximumOutputAlpha;
-            uniform highp vec3 gamma;
-
-            highp float linearstep(highp float e0, highp float e1, highp float x) {
-                return clamp((x - e0) / (e1 - e0), 0.0, 1.0);
-            }
-
-            void main(void) {
-                highp vec4 textureColor = texture2D(source, qt_TexCoord0.st);
-                highp vec4 color = vec4(textureColor.rgb / max(1.0/256.0, textureColor.a), textureColor.a);
-
-                color.r = linearstep(minimumInputRGB.r, maximumInputRGB.r, color.r);
-                color.g = linearstep(minimumInputRGB.g, maximumInputRGB.g, color.g);
-                color.b = linearstep(minimumInputRGB.b, maximumInputRGB.b, color.b);
-                color.a = linearstep(minimumInputAlpha, maximumInputAlpha, color.a);
-
-                color.rgb = pow(color.rgb, gamma);
-
-                color.r = minimumOutputRGB.r + color.r * (maximumOutputRGB.r - minimumOutputRGB.r);
-                color.g = minimumOutputRGB.g + color.g * (maximumOutputRGB.g - minimumOutputRGB.g);
-                color.b = minimumOutputRGB.b + color.b * (maximumOutputRGB.b - minimumOutputRGB.b);
-                color.a = minimumOutputAlpha + color.a * (maximumOutputAlpha - minimumOutputAlpha);
-
-                gl_FragColor = vec4(color.rgb * color.a, color.a) * qt_Opacity;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/leveladjust.frag"
     }
 }
diff --git a/src/effects/LinearGradient.qml b/src/effects/LinearGradient.qml
index 8d2d233..e268f8e 100644
--- a/src/effects/LinearGradient.qml
+++ b/src/effects/LinearGradient.qml
@@ -311,56 +311,13 @@ Item {
         property real angle: Math.atan2(dx, dy)
         property variant matrixData: Qt.point(Math.sin(angle), Math.cos(angle))
 
-        vertexShader: "
-            attribute highp vec4 qt_Vertex;
-            attribute highp vec2 qt_MultiTexCoord0;
-            uniform highp mat4 qt_Matrix;
-            varying highp vec2 qt_TexCoord0;
-            varying highp vec2 qt_TexCoord1;
-            uniform highp vec2 startPoint;
-            uniform highp float l;
-            uniform highp vec2 matrixData;
-
-            void main() {
-                highp mat2 rot = mat2(matrixData.y, -matrixData.x,
-                                      matrixData.x,  matrixData.y);
-
-                qt_TexCoord0 = qt_MultiTexCoord0;
-
-                qt_TexCoord1 = qt_MultiTexCoord0 * l;
-                qt_TexCoord1 -= startPoint * l;
-                qt_TexCoord1 *= rot;
-
-                gl_Position = qt_Matrix * qt_Vertex;
-            }
-        "
+        vertexShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/lineargradient.vert"
 
         fragmentShader: maskSource == undefined ? noMaskShader : maskShader
 
         onFragmentShaderChanged: lChanged()
 
-        property string maskShader: "
-            uniform lowp sampler2D source;
-            uniform lowp sampler2D maskSource;
-            uniform lowp float qt_Opacity;
-            varying highp vec2 qt_TexCoord0;
-            varying highp vec2 qt_TexCoord1;
-
-            void main() {
-                lowp vec4 gradientColor = texture2D(source, qt_TexCoord1);
-                lowp float maskAlpha = texture2D(maskSource, qt_TexCoord0).a;
-                gl_FragColor = gradientColor * maskAlpha * qt_Opacity;
-            }
-        "
-
-        property string noMaskShader: "
-            uniform lowp sampler2D source;
-            uniform lowp float qt_Opacity;
-            varying highp vec2 qt_TexCoord1;
-
-            void main() {
-                gl_FragColor = texture2D(source, qt_TexCoord1) * qt_Opacity;
-            }
-        "
+        property string maskShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/lineargradient_mask.frag"
+        property string noMaskShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/lineargradient_nomask.frag"
     }
 }
diff --git a/src/effects/OpacityMask.qml b/src/effects/OpacityMask.qml
index a247297..3935141 100644
--- a/src/effects/OpacityMask.qml
+++ b/src/effects/OpacityMask.qml
@@ -157,16 +157,6 @@ Item {
 
         anchors.fill: parent
 
-        fragmentShader: "
-            varying highp vec2 qt_TexCoord0;
-            uniform highp float qt_Opacity;
-            uniform lowp sampler2D source;
-            uniform lowp sampler2D maskSource;
-            void main(void) {
-                gl_FragColor = texture2D(source, qt_TexCoord0.st) * ("
-                    + (invert ? "1.0 - " : "")
-                    + "texture2D(maskSource, qt_TexCoord0.st).a) * qt_Opacity;
-            }
-        "
+        fragmentShader: invert ? "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/opacitymask_invert.frag" : "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/opacitymask.frag"
     }
 }
diff --git a/src/effects/RadialBlur.qml b/src/effects/RadialBlur.qml
index 002a965..5530625 100644
--- a/src/effects/RadialBlur.qml
+++ b/src/effects/RadialBlur.qml
@@ -37,7 +37,7 @@
 **
 ****************************************************************************/
 
-import QtQuick 2.0
+import QtQuick 2.8
 import QtGraphicalEffects.private 1.0
 
 /*!
@@ -286,7 +286,10 @@ Item {
         "
 
         function buildFragmentShader() {
-            var shader = fragmentShaderSkeleton
+            var shader = ""
+            if (GraphicsInfo.profile == GraphicsInfo.OpenGLCoreProfile)
+                shader += "#version 150 core\n#define varying in\n#define gl_FragColor fragColor\n#define texture2D texture\nout vec4 fragColor;\n"
+            shader += fragmentShaderSkeleton
             var expandSteps = ""
 
             if (transparentBorder) {
diff --git a/src/effects/RadialGradient.qml b/src/effects/RadialGradient.qml
index 2dcb1aa..287b26f 100644
--- a/src/effects/RadialGradient.qml
+++ b/src/effects/RadialGradient.qml
@@ -392,68 +392,13 @@ Item {
 
         anchors.fill: parent
 
-        vertexShader: "
-            attribute highp vec4 qt_Vertex;
-            attribute highp vec2 qt_MultiTexCoord0;
-            uniform highp mat4 qt_Matrix;
-            uniform highp vec2 matrixData;
-            uniform highp float horizontalRatio;
-            uniform highp float verticalRatio;
-            uniform highp vec2 center;
-            varying highp vec2 qt_TexCoord0;
-            varying highp vec2 qt_TexCoord1;
-            varying highp vec2 centerPoint;
-
-            void main() {
-                highp vec2 ratio = vec2(horizontalRatio, verticalRatio);
-
-                // Rotation matrix
-                highp mat2 rot = mat2(matrixData.y, -matrixData.x,
-                                      matrixData.x,  matrixData.y);
-
-                qt_TexCoord0 = qt_MultiTexCoord0;
-
-                qt_TexCoord1 = qt_MultiTexCoord0;
-                qt_TexCoord1 -= center;
-                qt_TexCoord1 *= rot;
-                qt_TexCoord1 += center;
-                qt_TexCoord1 *= ratio;
-
-                centerPoint = center * ratio;
-
-                gl_Position = qt_Matrix * qt_Vertex;
-            }
-        "
+        vertexShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/radialgradient.vert"
 
         fragmentShader: maskSource == undefined ? noMaskShader : maskShader
 
         onFragmentShaderChanged: horizontalRatioChanged()
 
-        property string maskShader: "
-            uniform lowp sampler2D gradientImage;
-            uniform lowp sampler2D maskSource;
-            uniform lowp float qt_Opacity;
-            varying highp vec2 qt_TexCoord0;
-            varying highp vec2 qt_TexCoord1;
-            varying highp vec2 centerPoint;
-
-            void main() {
-                lowp vec4 gradientColor = texture2D(gradientImage, vec2(0.0, 2.0 * distance(qt_TexCoord1, centerPoint)));
-                lowp float maskAlpha = texture2D(maskSource, qt_TexCoord0).a;
-                gl_FragColor = gradientColor * maskAlpha * qt_Opacity;
-            }
-        "
-
-        property string noMaskShader: "
-            uniform lowp sampler2D gradientImage;
-            uniform lowp float qt_Opacity;
-            varying highp vec2 qt_TexCoord1;
-            varying highp vec2 centerPoint;
-
-            void main() {
-                lowp vec4 gradientColor = texture2D(gradientImage, vec2(0.0, 2.0 * distance(qt_TexCoord1, centerPoint)));
-                gl_FragColor = gradientColor * qt_Opacity;
-            }
-        "
+        property string maskShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/radialgradient_mask.frag"
+        property string noMaskShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/radialgradient_nomask.frag"
     }
 }
diff --git a/src/effects/RectangularGlow.qml b/src/effects/RectangularGlow.qml
index d8eb82c..f8971c0 100644
--- a/src/effects/RectangularGlow.qml
+++ b/src/effects/RectangularGlow.qml
@@ -264,26 +264,6 @@ Item {
         property real spread: rootItem.spread / 2.0
         property real cornerRadius: clampedCornerRadius()
 
-        fragmentShader: "
-            uniform highp float qt_Opacity;
-            uniform mediump float relativeSizeX;
-            uniform mediump float relativeSizeY;
-            uniform mediump float spread;
-            uniform lowp vec4 color;
-            varying highp vec2 qt_TexCoord0;
-
-            highp float linearstep(highp float e0, highp float e1, highp float x) {
-                return clamp((x - e0) / (e1 - e0), 0.0, 1.0);
-            }
-
-            void main() {
-                lowp float alpha =
-                    smoothstep(0.0, relativeSizeX, 0.5 - abs(0.5 - qt_TexCoord0.x)) *
-                    smoothstep(0.0, relativeSizeY, 0.5 - abs(0.5 - qt_TexCoord0.y));
-
-                highp float spreadMultiplier = linearstep(spread, 1.0 - spread, alpha);
-                gl_FragColor = color * qt_Opacity * spreadMultiplier * spreadMultiplier;
-            }
-        "
+        fragmentShader: "qrc:/qt-project.org/imports/QtGraphicalEffects/shaders/rectangularglow.frag"
     }
 }
